#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>

static int Bol[32], Big[32], Clr[32];
static int stk=31;

static void SetVari(const char *s)
{
    unsigned r,g,b, bold, temp;     /* no 1 */
    static const char mirk[16] ={15, 2, 3,10, 5, 6, 7,15,
                                 14,12, 9,11, 4,13, 8,0};

    char R[3], G[3], B[3];
    R[0]=s[0], R[1]=s[1], R[2]=0;
    G[0]=s[2], G[1]=s[3], G[2]=0;
    B[0]=s[4], B[1]=s[5], B[2]=0;
    
    sscanf(R, "%X", &r);
    sscanf(G, "%X", &g);
    sscanf(B, "%X", &b);
    
    stk--;
    Big[stk] = Big[stk+1];
    Bol[stk] = 0;
    
    bold = (r>=128 || g>=128 || b>=128);
    temp =  r
            ?   g
                ?   b
                    ? /* rgb */ 7
                    : /* rg_ */ 6
                :   b
                    ? /* r_b */ 5
                    : /* r__ */ 4
            :   g
                ?   b
                    ? /* _gb */ 3
                    : /* _g_ */ 2
                :   b
                    ? /* __b */ 1
                    : /* ___ */ 0;
    
    Clr[stk] = mirk[temp + bold*8];
}
static void PopVari(void)
{
    stk++;
}

static void UpdColor(char **s, int reset)
{
    static int oldclr = -1;
    static int oldbold= -1;
    static int oldbig = -1;
    
    char *q = *s;
    
    if(reset)
        oldclr=-1, oldbold=-1, oldbig=-1;
    
    if(Bol[stk] != oldbold || Big[stk] != oldbig)
    {
    	if(oldbold || oldbig)
    	{
            *q++ = '';
            oldclr  = -1;
        }
        if(Bol[stk])*q++ = '';
        oldbold = Bol[stk];
        oldbig  = 0;
    }
    if(Clr[stk] != oldclr)
    {
        oldclr = Clr[stk];
        
        *q++ = '';
        if(Clr[stk] > 9)
            *q++ = '0' + (Clr[stk]/10);
        *q++ = '0' + (Clr[stk]%10);
        *q++ = ',';
        *q++ = '0';
        *q++ = '1';
        
        /*
        if(!Big[stk] || oldbig)
        {
            *q++ = '';
            *q++ = '';
        }
        */
    }
    if(Big[stk] && !oldbig)
    {
        oldbig = 1;
        *q++ = Clr[stk] ? '' : ''; /* hack */
    }
    *s = q;
}

int main(int argc, char **argv)
{
    int n=0;
    char Buf[512];
    FILE *fp;
    int tyh=0;
    int rivinro=0;
    int varit=1;
    
    enum {YLE,MTV3} mista = YLE;
    
    if(argv[1][0]=='-')
    {
        rivinro=-1;
        argv++;
        argc--;
    }
    
    if(argv[1][0]=='+')
    {
        varit = 0;
        argv++;
        argc--;
    }
    
    Buf[400]=0;
    if(argc > 1)
    {
        sprintf(Buf+400, argv[1]);
        if(argc > 2)
        {
            char *s = argv[2];
            if(*s=='M' || *s=='m' || *s=='3')
                mista = MTV3;
        }
    }
    if(Buf[403]=='/')
    {
        if(Buf[405])
            Buf[403]=Buf[404], Buf[404]=Buf[405], Buf[405]=0;
        else
            Buf[403]='0';
    }
    
    if(!isdigit(Buf[400])
    || !isdigit(Buf[401])
    || !isdigit(Buf[402]))
    {
        printf("Syntax error in `%s'", Buf+400);
Vihre:    printf(". Usage: .ttv <page>\n"
            "Pagenumbers are between 100-899.\n"
            "For subpages, use either 302/2 or 30202 format.\n");
        return 0;
    }
    
    strcpy(Buf, "lynx -source ");
    
    switch(mista)
    {
        case YLE:
            sprintf(Buf+13, "http://www.yle.fi/cgi-bin/tekstitv/ttv.cgi/txt?PAGE=%s", Buf+400);
            break;
        case MTV3:
            sprintf(Buf+13, "http://www.mtv3.fi/tekstikanava/%st.htm", Buf+400);
            break;
    }
    strcat(Buf, "|recode html..utf8");
    
    fp = popen(Buf, "r");
    
    argc = argc;
    
    for(;;)
    {
        char *s;
        if(!fgets(Buf, 511, fp))break;
        s = strstr(Buf, "PRE>");
        if(!s)s = strstr(Buf, "pre>");
        if(s)
        {
            if(++n)s += 4;
            if(mista==MTV3 && n > 1)break;
            if(n > 2)break;
        }
        if(n)
        {
            int rivi=0, len=0;
            char Rivi[512], *q=Rivi;
            if(!s)s=Buf;
            if(varit)UpdColor(&q, 1);
            for(; *s != '\n'; s++)
            {
                if(*s=='\r')continue;
                if(*s=='<')
                {
                    int set=1;
                    if(s[1]=='/')set=0, s++;
                    
                    if(s[1]=='f' || s[1]=='F')
                    {
                        while(*s!='#' && *s!='>')s++;
                        if(*s=='#')SetVari(s+1);
                        if(!set)PopVari();
                    }
                    else if(s[1]=='B' || s[1]=='b')Big[stk]=set;
                    else if(s[1]=='A' || s[1]=='a')Bol[stk]=!Bol[stk];
                    
                    while(*s != '>')s++;
                }
                else
                {
                    if(*s!=' '&&*s!='\t')rivi++;
                    if(varit)UpdColor(&q, 0);
                    *q++ = *s, len++;
                }
            }
            
            SetVari("000000");
            if(varit)UpdColor(&q, 0);            
            
            *q = 0;
            len = strlen(Rivi) - len;
            
            if(rivi)
            {
                if(rivinro >= 0)printf("%3d|", ++rivinro);
                *q = 0;
                printf("%s\n", Rivi);
            /*    printf("%*s|Len=%d\n", -(41+len), Rivi);
            */    tyh=0;
            }
            else if(++tyh < 2)
            {
                if(rivinro >= 0)printf("%3d|", ++rivinro);
                *q = 0;
                printf("%s\n", Rivi);
            /*    printf("%*s|len=%d\n", -(41+len), Rivi);
            */
            }
        }
    }
    if(n < 2)
    {
        printf("General failure");
        goto Vihre;
    }
    return 0;
}
